SystemOrganization addCategory: #HarryPotter!
SystemOrganization addCategory: 'HarryPotter-Tests'!

TestCase subclass: #EscuelaTest
	instanceVariableNames: 'harryPotter ron draco gryffindor slytherin hufflepuff ravenclaw hogwarts sombreroSombrerito avadaKedavra expelliarmus crucio desmaius flipendo expectoPatronum dumbledore voldemort molly bellatrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter-Tests'!

EscuelaTest class
	instanceVariableNames: 'sombreroSombrerito'!

!EscuelaTest commentStamp: '<historical>' prior: 0!
An EscuelaTest is a test class for testing the behavior of Escuela!

EscuelaTest class
	instanceVariableNames: 'sombreroSombrerito'!

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 23:20'!
setUp

hogwarts := Escuela new.
hogwarts inicializar.

harryPotter := Mago new.
harryPotter poderVarita: 200.
harryPotter colorPelo: 'marron'.
harryPotter inteligencia: 110.
harryPotter sangreSucia: true.
harryPotter miPadreEs: 'JuanPotter'.
harryPotter escuela: hogwarts.

ron := Mago new.
ron poderVarita:210.
ron colorPelo: 'rojo'.
ron inteligencia: 90.
ron sangreSucia: false.
ron miPadreEs: 'JuanWeasly'.
ron escuela: hogwarts.

draco := Mago new.
draco poderVarita: 80.
draco colorPelo: 'amarillo'.
draco inteligencia: 130.
draco sangreSucia: false.
draco miPadreEs: 'JuanMalfoy'.
draco escuela: hogwarts.

dumbledore := Mago new.
dumbledore poderVarita: 250.

voldemort := Mago new.
voldemort poderVarita: 250.

molly := Mago new.
molly poderVarita: 100.

bellatrix := Mago new.
bellatrix poderVarita: 80.

gryffindor := Gryffindor new.
gryffindor inicializar.

slytherin := Slytherin new.
slytherin inicializar.

ravenclaw := Ravenclaw new.
ravenclaw inicializar.

hufflepuff := Hufflepuff new. 
hufflepuff inicializar.

sombreroSombrerito := Sombrero new.

hogwarts agregarCasa: gryffindor.
hogwarts agregarCasa: slytherin.
hogwarts agregarCasa: ravenclaw.
hogwarts agregarCasa: hufflepuff.
hogwarts sombreroSeleccionador: sombreroSombrerito.

avadaKedavra := AvadaKedavra new.
expelliarmus := Expelliarmus new.

crucio := Imperdonable new.
crucio coeficiente: 50.

desmaius := Combate new.
desmaius coeficiente: 40.
flipendo := Combate new.
flipendo coeficiente: 20.

expectoPatronum := Sanador new.
expectoPatronum energiaQueGasta: 100.

Mago inicializarClase.

"Mago condiciones: Set new.
Mago condiciones add: [:mago | self esHermanoDe: mago].
Mago condiciones add: [:mago | mago inteligencia > self inteligencia ].
Mago condiciones add: [:mago | (mago escuela cuantosSiguenA: mago) > 3 ]."! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 01:01'!
testAtaquesEntreDumbledoreYVoldemort
voldemort aprenderHechizo: flipendo.
voldemort aprenderHechizo: desmaius.
dumbledore aprenderHechizo: expelliarmus.
dumbledore aprenderHechizo: flipendo.

voldemort atacarA: dumbledore.
voldemort atacarA: dumbledore.

self assert: (dumbledore energia) equals: 600.
self assert: (voldemort energia) equals: 600.
self assert: (dumbledore puntosDeVida) equals: 100.
self assert: (voldemort puntosDeVida) equals: 300.
! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 02:02'!
testDracoAprendeAvadaKedavraYFlipendo

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

draco aprenderHechizo: avadaKedavra.
draco aprenderHechizo: flipendo.

self assert: (draco hechizosAprendidos size) equals: 2.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 02:26'!
testDracoAtacaAHarry
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.

draco aprenderHechizo: flipendo.
harryPotter aprenderHechizo: crucio.
harryPotter aprenderHechizo: expectoPatronum.
harryPotter aprenderHechizo: expelliarmus.

draco poderVarita: 250.
draco atacarA: harryPotter.

self assert: (draco energia) equals: 800.
self assert: (harryPotter energia) equals: 1000.
self assert: (draco puntosDeVida) equals: 900.
self assert: (harryPotter puntosDeVida) equals: 600.
! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 00:18'!
testDracoEsAurorSeHaceMortifagoYSeVuelveAHacerAuror

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

ron seguirA: draco.
draco moral: Auror new.
draco aprenderHechizo: avadaKedavra.
draco aprenderHechizo: expectoPatronum.
harryPotter aprenderHechizo: flipendo.
draco atacarA: harryPotter.
draco recibirPerdonDeDumbledore.
4 timesRepeat: [draco lanzarHechizo: expectoPatronum AlMago: ron].

self assert: (harryPotter estaMuerto).
self assert: (draco moral class) equals: Auror.
self assert: (draco hechizosAprendidos size) equals: 2.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 23:40'!
testDracoEsAurorYSeHaceMortifago

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.

draco moral: Auror new.
draco aprenderHechizo: avadaKedavra.
harryPotter aprenderHechizo: flipendo.
draco atacarA: harryPotter.

self assert: (harryPotter estaMuerto).
self assert: (draco moral class) equals: Mortifago.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:19'!
testDracoInsultaAHarry

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

harryPotter esInsultadoPor: draco.

self assert: (harryPotter esEnemigoDe: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 21:04'!
testDracoMortifagoConMarcaTenebrosaYAtacaARon

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

draco moral: Mortifago new.
draco aprenderHechizo: avadaKedavra.
draco aprenderHechizo: desmaius.
draco atacarA: harryPotter.
draco lanzarHechizo: desmaius AlMago: ron.

self assert: (harryPotter estaMuerto).
self assert: (draco tieneMarcaTenebrosa).
self assert: (ron puntosDeVida) equals: 520.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 21:05'!
testDracoMortifagoSinMarcaTenebrosaYAtacaARon

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

draco aprenderHechizo: avadaKedavra.
draco aprenderHechizo: desmaius.
draco atacarA: harryPotter.
draco lanzarHechizo: desmaius AlMago: ron.

self assert: (harryPotter estaMuerto).
self deny: (draco tieneMarcaTenebrosa).
self assert: (ron puntosDeVida) equals: 620.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 00:57'!
testDueloMortalEntreMollyYBellatrix

molly aprenderHechizo: flipendo.
molly aprenderHechizo: desmaius.
bellatrix aprenderHechizo: flipendo.

bellatrix puntosDeVida: 400.

molly retarADueloA: bellatrix.

self assert: (molly energia) equals: 600.
self assert: (bellatrix energia) equals: 800.
self assert: (molly puntosDeVida) equals: 820.
self assert: (bellatrix estaMuerto).
! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 02:10'!
testEnergiaQueGastarianLosHechizosDeDraco
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

ron seguirA: draco.

draco aprenderHechizo: avadaKedavra.
draco aprenderHechizo: flipendo.
draco aprenderHechizo: expelliarmus.
draco aprenderHechizo: expectoPatronum.
draco aprenderHechizo: crucio.

self assert: (avadaKedavra energiaQueGasta) equals: 0.
self assert: (flipendo energiaQueGasta) equals: 200.
self assert: (expelliarmus energiaQueGasta) equals: 0.
self assert: (expectoPatronum energiaQueGasta) equals: 100.
self assert: (crucio energiaQueGasta) equals: 0.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 01:48'!
testHarryAprendeExpectoPatronum

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: harryPotter.
harryPotter aprenderHechizo: expectoPatronum.

self assert: (harryPotter hechizosAprendidos size) equals: 1.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 02:12'!
testHarryEsAurorYLoAtacan

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
harryPotter moral: Auror new.
ron seguirA: harryPotter.

harryPotter aprenderHechizo: expectoPatronum.
draco aprenderHechizo: expelliarmus.
draco atacarA: harryPotter.

self assert: (ron energia) equals: 2000.
! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 21:33'!
testHarryPotterLanzaExpectoPatronumARon

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: harryPotter.
harryPotter aprenderHechizo: expectoPatronum.
harryPotter lanzarHechizo: expectoPatronum AlMago: ron.

self assert: (harryPotter energia) equals: 900.
self assert: (ron puntosDeVida) equals: 1200.
! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 22:51'!
testHarryPotterLanzaExpectoPatronumARonMuerto

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: harryPotter.
harryPotter aprenderHechizo: expectoPatronum.
harryPotter lanzarHechizo: expectoPatronum AlMago: ron.
ron puntosDeVida: 0.

self assert: (harryPotter energia) equals: 900.
self assert: (ron puntosDeVida) equals: 0.
! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:03'!
testHarryQuiereSeguirARonperoNoPuede

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self deny: (harryPotter puedoSeguirA: ron).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 02:30'!
testHechizoQueMasVidaSacariaADracoHechoPorHarry
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.

harryPotter aprenderHechizo: crucio.
harryPotter aprenderHechizo: expectoPatronum.
harryPotter aprenderHechizo: expelliarmus.


self assert: (harryPotter hechizoQueMasAfectaLaVidaDeAdversario: draco) equals: crucio.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 02:04'!
testHechizoQueMasVidaSacariaAHarryHechoPorDraco
(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

ron seguirA: draco.

draco aprenderHechizo: avadaKedavra.
draco aprenderHechizo: flipendo.
draco aprenderHechizo: desmaius.
draco aprenderHechizo: expelliarmus.
draco aprenderHechizo: expectoPatronum.
draco aprenderHechizo: crucio.

self assert: (draco hechizoQueMasAfectaLaVidaDeAdversario: harryPotter) equals: avadaKedavra.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:25'!
testPreguntarAlSombreroAQueCasaEntraHarryPotter

self assert: (hogwarts aQueCasaLeCorrespondeIr: harryPotter ) equals: gryffindor.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:13'!
testPreguntarSiDracoEntraEnSlytherin

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

self assert: (slytherin estaAca: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:58'!
testPreguntarSiHarryNoEntraEnSlytherin

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.

self deny: (slytherin estaAca: harryPotter).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 02:29'!
testPuntosDeVidaQueCrucioRestaADracoAtacadoPorHarry

self assert: (crucio puntosDeVidaQueRestaAlReceptor: draco atacadoPor: harryPotter) equals: 100.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 01:59'!
testRonNoPuedeAprenderExpectoPatronum

(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

ron aprenderHechizo: expectoPatronum.


self assert: (ron hechizosAprendidos size) equals: 0.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:23'!
testRonPuedeSeguirADraco

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (ron puedoSeguirA: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:11'!
testRonPuedeSeguirAHarry

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (ron puedoSeguirA: harryPotter).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:29'!
testRonSigueADraco

(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: draco.

self assert: (hogwarts cuantosSiguenA: draco) equals: 1.
self assert: (ron seguisA: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:17'!
testRonSigueAHarry

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: harryPotter.

self assert: (hogwarts cuantosSiguenA: harryPotter) equals: 1.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:28'!
testRonSigueAHarryYADracoPeroDracoInsultaAHarry

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.
ron seguirA: harryPotter.
ron seguirA: draco.
harryPotter esInsultadoPor: draco.

self assert: (hogwarts cuantosSiguenA: harryPotter) equals: 1.
self assert: (hogwarts cuantosSiguenA: draco) equals: 0.
self deny: (ron seguisA: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:21'!
testRonSigueAHarryYHarryInsultaARon

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: harryPotter.
ron esInsultadoPor: harryPotter.

self assert: (hogwarts cuantosSiguenA: harryPotter) equals: 0.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 01:37'!
testSaberCuantosSiguenAHarry

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: harryPotter.

self assert: (hogwarts cuantosSiguenA: harryPotter) equals: 1.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 12:27'!
testSaberCuantosSiguenARon

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (hogwarts cuantosSiguenA: ron) equals: 0.! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:27'!
testSaberQueCasaTieneMasMagos

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

self assert: (hogwarts queCasaTieneMasMagos) equals: gryffindor .! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 01:01'!
testSaberSiHarryPotterEstaEnLaMismaCasaQueDraco

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: draco) agregarMago: draco.

self deny: (hogwarts esta: harryPotter enLaMismaCasaQue: draco).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:13'!
testSaberSiHarryPotterEstaEnLaMismaCasaQueRon

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.

self assert: (hogwarts esta: harryPotter enLaMismaCasaQue: ron).! !

!EscuelaTest methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 01:54'!
testSaberSiHarryTieneSeguidores

(hogwarts aQueCasaLeCorrespondeIr: harryPotter) agregarMago: harryPotter.
(hogwarts aQueCasaLeCorrespondeIr: ron) agregarMago: ron.
ron seguirA: harryPotter.

self assert: (harryPotter tieneSeguidores).! !

Object subclass: #Casa
	instanceVariableNames: 'magos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Casa methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/16/2014 00:51'!
agregarMago: unMago
magos add: unMago.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
cantidadDeMagos
^magos size.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 16:10'!
cuantosSiguenA: unMago

^(self quienesSiguenA: unMago) size.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
estaAca: unMago
^magos includes: unMago.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:51'!
hacerQueSeguidoresDe: unMago seanEnemigosDe: otroMago
(self quienesSiguenA: unMago) do: [ :mago | mago agregarEnemigo: otroMago ]! !

!Casa methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:32'!
inicializar
magos := Set new.! !

!Casa methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:35'!
quienesSiguenA: unMago
| coleccionQuienesSiguenAUnMago |
^coleccionQuienesSiguenAUnMago := (magos select: [:mago | mago seguisA: unMago]).
! !

Casa subclass: #Gryffindor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Gryffindor methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 10:22'!
aceptaA: unMago
^(unMago esPelirrojo | unMago inteligenciaPromedio).! !

Casa subclass: #Hufflepuff
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Hufflepuff methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 22:55'!
aceptaA: unMago
^true.! !

Casa subclass: #Ravenclaw
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Ravenclaw methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 18:40'!
aceptaA: unMago
^(unMago muyInteligente).! !

Casa subclass: #Slytherin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Slytherin methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/7/2014 00:43'!
aceptaA: unMago
^(unMago sangreSucia) not! !

Object subclass: #Escuela
	instanceVariableNames: 'casas sombreroSeleccionador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Escuela methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/16/2014 02:05'!
aQueCasaLeCorrespondeIr: unMago
^sombreroSeleccionador casaQueCorrespondeA: unMago deEstasCasas:  casas.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
agregarCasa: unaCasa
casas add: unaCasa.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 12:24'!
cuantosSiguenA: unMago
^(casas sum:[:casa | casa cuantosSiguenA: unMago]).
! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:50'!
elMago: unMago fueInsultadoPor: otroMago
casas do: [ :casa |  casa hacerQueSeguidoresDe: unMago seanEnemigosDe: otroMago ]! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 10:54'!
esta: unMago enLaMismaCasaQue: otroMago
^((casas detect:[:casa | (casa estaAca: unMago)] ) estaAca: otroMago).! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:30'!
inicializar 
casas := OrderedCollection  new.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 10:59'!
queCasaTieneMasMagos
^casas detectMax:[:casa | casa cantidadDeMagos ].! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 01:22'!
seguidoresDe: unMago
^casas gather: [:casa | casa quienesSiguenA: unMago].! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:09'!
sombreroSeleccionador
^sombreroSeleccionador.! !

!Escuela methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 19:09'!
sombreroSeleccionador: sombrero
sombreroSeleccionador := sombrero.! !

Object subclass: #Hechizo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

Hechizo subclass: #AvadaKedavra
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!AvadaKedavra methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/30/2014 02:06'!
puntosDeVidaQueRestaAlReceptor: receptor atacadoPor: emisor
^receptor puntosDeVida! !

!AvadaKedavra methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 20:55'!
realizarConsecuenciasEnReceptor: receptor yEmisor: emisor
emisor restarPuntosDeVida: ((self puntosDeVidaTotalesQueSeRestanAlReceptor: receptor atacadoPor: emisor) / 2).
receptor restarPuntosDeVida: (self puntosDeVidaTotalesQueSeRestanAlReceptor: receptor atacadoPor: emisor).! !

Hechizo subclass: #Combate
	instanceVariableNames: 'energia coeficiente'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Combate methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:06'!
coeficiente
^coeficiente.! !

!Combate methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:07'!
coeficiente: valor
coeficiente:=valor.! !

!Combate methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 15:33'!
energiaQueGasta
^energia.! !

!Combate methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 15:32'!
energiaQueGasta: valor
energia:=valor.! !

!Combate methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 15:38'!
initialize
self energiaQueGasta: 200.! !

!Combate methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 02:05'!
puntosDeVidaQueRestaAlReceptor: receptor atacadoPor: emisor
^5*(self coeficiente) + emisor poderVarita.! !

!Combate methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 20:56'!
realizarConsecuenciasEnReceptor: receptor yEmisor: emisor
emisor gastarEnergia: (self energiaQueGasta).
receptor restarPuntosDeVida: (self puntosDeVidaTotalesQueSeRestanAlReceptor: receptor atacadoPor: emisor).! !

Hechizo subclass: #Expelliarmus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Expelliarmus methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/30/2014 23:12'!
intercambiarVaritasDeUnMago: unMago yOtroMago: otroMago
|poderVarita|
poderVarita := unMago poderVarita.
unMago poderVarita: (otroMago poderVarita).
otroMago poderVarita: poderVarita.! !

!Expelliarmus methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 21:49'!
realizarConsecuenciasEnReceptor: receptor yEmisor: emisor
(receptor poderVarita > emisor poderVarita) ifTrue: [ self intercambiarVaritasDeUnMago: receptor yOtroMago: emisor ]! !

!Hechizo methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 01:05'!
agregarseA: unMago
unMago agregarHechizo: self.! !

!Hechizo methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 02:07'!
energiaQueGasta
^0! !

!Hechizo methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 20:57'!
puntosDeVidaQueRestaAlReceptor: receptor atacadoPor: emisor
^0! !

!Hechizo methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 20:55'!
puntosDeVidaTotalesQueSeRestanAlReceptor: receptor atacadoPor: emisor
^(self puntosDeVidaQueRestaAlReceptor: receptor atacadoPor: emisor) + ((emisor moral) puntosDeVidaQueRestaEnUnHechizo: emisor)! !

!Hechizo methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 21:24'!
realizarHechizoAlReceptor: receptor DelEmisor: emisor
self realizarConsecuenciasEnReceptor: receptor yEmisor: emisor.
(receptor estaMuerto ) ifTrue: [ emisor matoAUnMago ] ! !

Hechizo subclass: #Imperdonable
	instanceVariableNames: 'coeficiente'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Imperdonable methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:08'!
coeficiente
^coeficiente.! !

!Imperdonable methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:08'!
coeficiente: valor
coeficiente:=valor.! !

!Imperdonable methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 02:30'!
puntosDeVidaQueRestaAlReceptor: receptor atacadoPor: emisor
^2*(self coeficiente - (4* ((emisor escuela) cuantosSiguenA: emisor)) )! !

!Imperdonable methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 20:56'!
realizarConsecuenciasEnReceptor: receptor yEmisor: emisor
emisor restarPuntosDeVida: ((self puntosDeVidaTotalesQueSeRestanAlReceptor: receptor atacadoPor: emisor) / 2 ).
receptor restarPuntosDeVida: (self puntosDeVidaTotalesQueSeRestanAlReceptor: receptor atacadoPor: emisor).! !

Hechizo subclass: #Sanador
	instanceVariableNames: 'energia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Sanador methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 01:06'!
agregarseA: unMago
(unMago tieneSeguidores) ifTrue: [unMago agregarHechizo: self].! !

!Sanador methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 15:33'!
energiaQueGasta
^energia.! !

!Sanador methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 15:32'!
energiaQueGasta: valor
energia:=valor.! !

!Sanador methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 15:58'!
puntosDeVidaQueSuma
^(self energiaQueGasta) * 2! !

!Sanador methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 21:25'!
realizarConsecuenciasEnReceptor: receptor yEmisor: emisor
emisor gastarEnergia: (self energiaQueGasta).
(receptor estaVivo) ifTrue: [receptor sumarPuntosDeVida: (self puntosDeVidaQueSuma). emisor realizoUnaCuracion].
! !

Object subclass: #Mago
	instanceVariableNames: 'colorPelo inteligencia sangreSucia enemigos padre escuela losQueSigo puntosDeVida energia poderVarita hechizosAprendidos moral tieneMarcaTenebrosa'
	classVariableNames: 'condiciones'
	poolDictionaries: ''
	category: 'HarryPotter'!

!Mago class methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 21:10'!
condiciones
^condiciones! !

!Mago class methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 21:11'!
condiciones: anObject
condiciones := anObject! !

!Mago class methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 23:33'!
inicializarClase
self condiciones: Set new.
self condiciones add: [:mago :otroMago | mago esHermanoDe: otroMago].
self condiciones add: [:mago :otroMago | otroMago inteligencia > mago inteligencia ].
self condiciones add: [:mago :otroMago | (otroMago escuela cuantosSiguenA: otroMago) > 3 ].! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 20:17'!
adquirirMarcaTenebrosa
self tieneMarcaTenebrosa: true.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:13'!
agregarAQuienSigo: unMago
losQueSigo add: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 02:05'!
agregarEnemigo:unMago
enemigos add: unMago.
(self seguisA: unMago) ifTrue: [ losQueSigo remove: unMago ].! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 01:05'!
agregarHechizo: hechizo
self hechizosAprendidos add: hechizo! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 01:01'!
aprenderHechizo: hechizo
hechizo agregarseA: self.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 23:30'!
atacarA: adversario
self lanzarHechizoMasPotenteAlMago: adversario.
adversario defenderseDe: self.
! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo
^colorPelo! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:01'!
colorPelo: color
colorPelo := color! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 02:11'!
defenderseDe: unMago
self moral elMago: self seDefiendeDe: unMago! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 01:23'!
duplicarEnergia
self energia: (self energia * 2)! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 01:23'!
duplicarEnergiaDeSeguidores
self seguidores do: [ :seguidor | seguidor duplicarEnergia ]! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 10/30/2014 01:55'!
enemigos
	^ enemigos! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 10/30/2014 01:55'!
enemigos: anObject
	enemigos := anObject! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 16:49'!
energia
^energia.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 16:49'!
energia: valor
energia:=valor.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:46'!
esEnemigoDe: unMago
^(enemigos includes: unMago).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:47'!
esHermanoDe: unMago
^( (padre = unMago miPadreEs) & (self ~= unMago) ).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/8/2014 15:52'!
esInsultadoPor: unMago
self agregarEnemigo: unMago.
escuela elMago: self fueInsultadoPor: unMago.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 18:39'!
esPelirrojo
^self colorPelo = 'rojo'! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:57'!
escuela
^escuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 01:56'!
escuela: unaEscuela
escuela:=unaEscuela.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 21:42'!
estaMuerto
^(self estaVivo) not! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 00:49'!
estaVivo
^self puntosDeVida > 0! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 16:07'!
gastarEnergia: cantidad
self energia: (energia - cantidad)! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/30/2014 02:16'!
hechizoQueMasAfectaLaVidaDeAdversario: adversario
^self hechizosAprendidos detectMax: [ :hechizo | hechizo puntosDeVidaQueRestaAlReceptor: adversario atacadoPor: self ]! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 20:15'!
hechizosAprendidos
	^ hechizosAprendidos ! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 20:15'!
hechizosAprendidos: anObject
	hechizosAprendidos := anObject! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 20:37'!
incrementarCuracionesHechas
self curaciones: (self curaciones + 1)! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 21:21'!
initialize
self losQueSigo: Set new.
self enemigos: Set new.
self hechizosAprendidos: Set new.
self moral: Neutro new.
self puntosDeVida: 1000.
self energia: 1000.
self tieneMarcaTenebrosa: false.
! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:09'!
inteligencia
^inteligencia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:04'!
inteligencia: numero
inteligencia := numero! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/7/2014 00:40'!
inteligenciaPromedio
^(self inteligencia >80) & (self inteligencia <120)! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 21:24'!
lanzarHechizo: hechizo AlMago: receptor
(self hechizosAprendidos includes: hechizo) ifFalse: [ Error signal: 'El mago no sabe hacer el hechizo' ].
(self energia < hechizo energiaQueGasta) ifTrue: [ Error signal: 'El mago no tiene suficiente energía para realizar el hechizo' ].
hechizo realizarHechizoAlReceptor: receptor DelEmisor: self.
! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 23:31'!
lanzarHechizoMasPotenteAlMago: receptor 
self lanzarHechizo: (self hechizoQueMasAfectaLaVidaDeAdversario: receptor) AlMago: receptor! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 10/30/2014 01:55'!
losQueSigo
	^ losQueSigo! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 10/30/2014 01:55'!
losQueSigo: anObject
	losQueSigo := anObject! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 19:43'!
matoAUnMago
self moral unMagoFueMatadoPor: self.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/5/2014 23:43'!
miPadreEs 
^padre.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:49'!
miPadreEs: valor
padre := valor.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:21'!
moral
^moral.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 18:21'!
moral: valor
moral:=valor.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/6/2014 00:40'!
muyInteligente
^(self inteligencia) >= 120! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 17:12'!
poderVarita
^poderVarita. ! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWagner 10/26/2014 17:13'!
poderVarita:valor
poderVarita:=valor. ! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 23:31'!
puedoSeguirA: unMago

^((self esEnemigoDe: unMago) not) & (self ~= unMago) & ((self class) condiciones anySatisfy:[:condicion | condicion value: self value: unMago]).





! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 11/2/2014 21:28'!
puntosDeVida
	^ puntosDeVida! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 11/2/2014 21:32'!
puntosDeVida: puntos
puntosDeVida := puntos! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 21:18'!
realizoUnaCuracion
self moral realizoUnaCuracion: self! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 23:16'!
recibirPerdonDeDumbledore
self moral recibioElPerdonDeDumbledore: self! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 16:11'!
restarPuntosDeVida: cantidad
self puntosDeVida: (self puntosDeVida - cantidad)! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 00:57'!
retarADueloA: unMago
[(self estaVivo & unMago estaVivo)] whileTrue: [self atacarA: unMago]! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:22'!
sangreSucia
^sangreSucia! !

!Mago methodsFor: 'as yet unclassified' stamp: 'Juan 9/30/2014 10:12'!
sangreSucia: valor
sangreSucia := valor! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 01:22'!
seguidores
^self escuela seguidoresDe: self! !

!Mago methodsFor: 'as yet unclassified' stamp: 'LeandroWager 10/7/2014 11:42'!
seguirA: unMago
(self puedoSeguirA: unMago) ifTrue:[losQueSigo add: unMago].! !

!Mago methodsFor: 'as yet unclassified' stamp: 'MaximilianoCantarell 10/6/2014 02:11'!
seguisA: unMago
^(losQueSigo includes: unMago).! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/27/2014 16:11'!
sumarPuntosDeVida: cantidad
self puntosDeVida: (self puntosDeVida + cantidad)! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 20:16'!
tieneMarcaTenebrosa
	^ tieneMarcaTenebrosa! !

!Mago methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 20:16'!
tieneMarcaTenebrosa: anObject
	tieneMarcaTenebrosa := anObject! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/31/2014 01:55'!
tieneSeguidores
^((self escuela) cuantosSiguenA: self) > 0! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 19:35'!
volverseAuror
self moral: Auror new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 19:34'!
volverseMortifago
self moral: Mortifago new.! !

!Mago methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 19:35'!
volverseNeutro
self moral: Neutro new.! !

Object subclass: #Moral
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

Moral subclass: #Auror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Auror methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 02:11'!
elMago: unMago seDefiendeDe: otroMago
super elMago: unMago seDefiendeDe: otroMago.
unMago duplicarEnergiaDeSeguidores.! !

!Auror methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 01:16'!
recibioUnHechizoDeAtaque: unMago
unMago duplicarEnergiaDeSeguidores! !

!Moral methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 02:10'!
elMago: unMago seDefiendeDe: otroMago
(unMago estaVivo) ifTrue: [unMago lanzarHechizoMasPotenteAlMago: otroMago].
! !

!Moral methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 20:52'!
puntosDeVidaQueRestaEnUnHechizo: unMago
^0! !

!Moral methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 21:22'!
realizoUnaCuracion: unMago! !

!Moral methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 20:25'!
recibioElPerdonDeDumbledore: unMago! !

!Moral methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/2/2014 01:13'!
recibioUnHechizoDeAtaque: unMago! !

!Moral methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 11/1/2014 20:25'!
unMagoFueMatadoPor: unMago
unMago volverseMortifago! !

Moral subclass: #Mortifago
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Mortifago methodsFor: 'accessing' stamp: 'JessSaavedra 11/2/2014 20:59'!
puntosDeVidaQueRestaEnUnHechizo: unMago
(unMago tieneMarcaTenebrosa) ifTrue: [ ^200 ] ifFalse: [ ^100 ]! !

!Mortifago methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 19:49'!
recibioElPerdonDeDumbledore: unMago
unMago volverseNeutro ! !

!Mortifago methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 20:17'!
unMagoFueMatadoPor: unMago
unMago adquirirMarcaTenebrosa ! !

Moral subclass: #Neutro
	instanceVariableNames: 'curaciones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Neutro methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 21:16'!
curaciones
	^ curaciones! !

!Neutro methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 21:16'!
curaciones: anObject
	curaciones := anObject! !

!Neutro methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 21:17'!
initialize
self curaciones: 0! !

!Neutro methodsFor: 'accessing' stamp: 'JessSaavedra 11/1/2014 21:19'!
realizoUnaCuracion: unMago
self curaciones: (self curaciones + 1).
(self curaciones = 4) ifTrue: [ unMago volverseAuror ].! !

Object subclass: #Sombrero
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HarryPotter'!

!Sombrero methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/16/2014 02:04'!
asignarCasaA: unMago deEstasCasas: lasCasas 
(self casaQueCorrespondeA: unMago) agregarMago: unMago.
! !

!Sombrero methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/16/2014 02:03'!
casaQueCorrespondeA: unMago deEstasCasas: lasCasas 
^lasCasas detect: [ :unaCasa | unaCasa aceptaA: unMago].! !
